package com.example.android.constantesvitales;

import android.content.res.Resources;
import android.util.Log;
import org.json.JSONObject;
import org.json.JSONException;

import java.util.ArrayList;
//private static final String RESPUESTA = "{\"datos\":{\"ppg\":1000,\"oxigeno\":98,\"pulso\":60}}";

public final class ObtencionDatos {

    private ObtencionDatos(String json){
    }

    public static ArrayList<com.example.android.constantesvitales.ConstanteVital> getListaConstantes
            (Paciente paciente, String mensaje, Resources r){

        ArrayList<com.example.android.constantesvitales.ConstanteVital> listaConstantesVitales =
                new ArrayList<>();

        try {
            JSONObject jsonObject = new JSONObject(mensaje);
            JSONObject datos = jsonObject.getJSONObject("datos");

            listaConstantesVitales.add(new com.example.android.constantesvitales.ConstanteVital
                    (r.getString(R.string.imc), calculaImc(paciente), R.drawable.ic_imc_foreground));
            listaConstantesVitales.add(new com.example.android.constantesvitales.ConstanteVital
                    (r.getString(R.string.ppg), datos.getInt("ppg"),
                            R.drawable.ic_ppg_foreground));
            listaConstantesVitales.add(new com.example.android.constantesvitales.ConstanteVital
                    (r.getString(R.string.oxigeno), datos.getInt("oxigeno"),
                            R.drawable.ic_oxigeno_foreground));
            listaConstantesVitales.add(new com.example.android.constantesvitales.ConstanteVital
                    (r.getString(R.string.ppm), datos.getInt("pulso"),
                            R.drawable.ic_corazon_foreground));
        }
        catch (JSONException e){
            Log.e("ObtencionDatos", "Error en la extracción del formato JSON", e);
        }

        return listaConstantesVitales;
    }


    private static double calculaImc(@org.jetbrains.annotations.NotNull Paciente paciente){
        double altura = paciente.getAltura();
        double peso = paciente.getPeso();
        if(altura>0 && peso>0)
            return  peso/(altura*altura/10000);
        else
            return -1;
    }
}

