#define B_RATE_RAPIDO 115200
#define B_RATE_LENTO 9600

#define T_SERVICIO 200

#define LED_IR 23
#define LED_R 24
#define Vo0 A0
#define Vo1 A1
#define Vo2 A2

unsigned long t_ciclo;
float lectura_R[3]={0,0,0}; 
float lectura_IR[3]={0,0,0};

/////////////////////////////////////////////////////////////////////////////
void setup() 
{
  Serial.begin(B_RATE_LENTO);
  
  pinMode(LED_IR, OUTPUT);
  pinMode(LED_R, OUTPUT);
  pinMode(Vo0, INPUT);
  pinMode(Vo1, INPUT);
  pinMode(Vo2, INPUT);
  
  analogReference(AR_DEFAULT);        //Referencia de AnalogRead a 3.3V
  analogWriteResolution(10);          //10 bits (0-1023) para valores de tensión de salida
  analogReadResolution(12);           //12 bits (0-4095) para lectura de tensión
  
  digitalWrite(LED_IR, LOW);
  digitalWrite(LED_R, LOW);
}


/////////////////////////////////////////////////////////////////////////////
void loop()
{
  t_ciclo=micros();

  Pulso_LED(LED_IR);
  while((micros()-t_ciclo)<500)
    continue;
  
  Pulso_LED(LED_R);
  while((micros()-t_ciclo)<1000)
    continue;
  
  Envia_Datos(LED_R);
}


/////////////////////////////////////////////////////////////////////////////
void Pulso_LED(int led)
{
  unsigned long t=micros();
  int v0, v1, v2;
  
  digitalWrite(led, HIGH);

  while((micros()-t)<T_SERVICIO)
  {
      v0=analogRead(Vo0);
      v1=analogRead(Vo1);
      v2=analogRead(Vo2);
  }

  digitalWrite(led, LOW);
  
  if(led==LED_IR)
    {
      lectura_IR[0]=v0*3.3*1000/4095;
      lectura_IR[1]=v1*3.3*1000/4095;
      lectura_IR[1]=v2*3.3*1000/4095;
    }
    else
    {
      lectura_R[0]=v0*3.3*1000/4095;
      lectura_R[1]=v1*3.3*1000/4095;
      lectura_R[2]=v2*3.3*1000/4095;
    }
}


//////////////////////////////////////////////////////////////////////////////
void Envia_Datos(int led)
{
  // lectura=(V0_IR, V1_IR, V0_R, V1_R)
  
      //Salida antes de los filtros
      Serial.print(lectura_IR[0]);
      Serial.print(",");
      Serial.print(lectura_R[0]);
      Serial.print(",");
  
      //Salida despues de los filtros
      Serial.print(lectura_IR[1]);
      Serial.print(",");
      Serial.print(lectura_R[1]);
      Serial.print(",");
      Serial.print(lectura_IR[2]);
      Serial.print(",");
      Serial.println(lectura_R[2]);
      
      
  }


//////////////////////////////////////////////////////////////////////////////
float Lectura_Vo0()
{
  return(analogRead(Vo0)*3.3*1000/4095);
}

//////////////////////////////////////////////////////////////////////////////
float Lectura_Vo1()
{
  return(analogRead(Vo1)*3.3*1000/4095);
}

//////////////////////////////////////////////////////////////////////////////
float Lectura_Vo2()
{
  return(analogRead(Vo2)*3.3*1000/4095);
}
